import re

with open('reverse.txt', 'r') as file:
    text2 = file.read()

# Reversing the values
rg = re.compile(r'\$[0-9A-Fa-f]+\$', re.MULTILINE | re.IGNORECASE)

for match in rg.finditer(text2):
    hex_str = match.group(0)[1:-1]  # extract the hexadecimal string
    bytes_arr = bytes.fromhex(hex_str)  # convert to bytes array
    bytes_arr_reversed = bytes_arr[::-1]  # reverse the byte order
    new_hex_str = bytes_arr_reversed.hex().lower()  # convert to reversed hexadecimal string and lowercase
    new_match_str = "${}$".format(new_hex_str)  # create new match string with reversed hexadecimal string
    text2 = text2.replace(match.group(0), new_match_str)  # replace old match string with new one

# Replacing the values from the dictionary
thaw_dict = {}
with open('thaw_keys.txt', 'r') as f:
    for line in f:
        key, value = line.strip().split(' ', 1)
        thaw_dict[key] = value

for key, value in thaw_dict.items():
    text2 = text2.replace('$'+key+'$', '$'+value+'$')

with open('decompile.txt', 'w') as f:
    f.write(text2)
